#include "Dummy.h"
#include "BzWindow.h"
#include <Application.h>
#include <Box.h>
#include <TextControl.h>
#include <Button.h>
#include <FilePanel.h>
#include <StringView.h>
#include <Alert.h>

#define PREFS_H 250
#define PREFS_L 400


Dummy::Dummy(){}

void
Dummy::showConfig()
{
	/* here the new BzWindow is created with alla the controls and views */

	BBox *box,*box2;
	BTextControl	*txt;
	BzWindow *win=new BzWindow(BRect(0,0,PREFS_L,PREFS_H),"", B_DOCUMENT_WINDOW,0);

	
	win->AddChild(box=new BBox(win->Bounds(),"",B_FOLLOW_ALL_SIDES,B_WILL_DRAW,B_PLAIN_BORDER));
	BRect r(box->Bounds());
	r.InsetBy(20,20);
	r.bottom -=30;
	box->AddChild(box2=new BBox(r,"General Prefs",B_FOLLOW_ALL_SIDES,B_WILL_DRAW,B_FANCY_BORDER));
	box2->SetLabel("General Prefs");
	r=box2->Bounds();
	
	r.left +=20;
	r.right -=100;
	r.top=50;
	r.bottom =r.top+20;
	
	box2->AddChild( txt=new BTextControl(r,"vstfolder","VST Folder :","< not yet set >",B_FOLLOW_NONE,B_WILL_DRAW) );
	
	r.left=r.right+20;
	r.right=r.right+=80;
	
	box2->AddChild(new BButton(r,"set","set",new BMessage('Set'),B_FOLLOW_NONE,B_WILL_DRAW));
	
	r=box2->Bounds();
	
	r.left +=20;
	r.right -=100;
	r.top=150;
	r.bottom =r.top+20;
	
	box2->AddChild(new BStringView(r,"set","Save and restart to apply this settings.",B_FOLLOW_NONE,B_WILL_DRAW));
	
	r=box2->Frame();
	r.top=r.bottom+5;
	r.bottom =r.top+20;
	r.left= r.right-50;
	
	box->AddChild(new BButton(r,"set","Cancel",new BMessage('Canc'),B_FOLLOW_NONE,B_WILL_DRAW));
	
	
	r.left= r.right-105;
	r.right =r.left+50;	

	box->AddChild(new BButton(r,"set","Save",new BMessage('Save'),B_FOLLOW_NONE,B_WILL_DRAW));
	
		
	win->MoveTo(BAlert::AlertPosition(PREFS_L,PREFS_H));
	
	
	
	/* Redirect the MessageReceived to a local (and static) function */
	
	win->RedirectMessages(Dummy::msgConfig,(void*)win);
	
	win->Show();
	
}

bool
Dummy::msgConfig(BMessage* message,void* cookies)
{
	/* replay to messages :) */

	BzWindow *win=(BzWindow*)cookies;

	entry_ref rif;
	
	switch(message->what)
	{
		case 'Set':
			{
			BMessenger *m=new BMessenger(NULL,win);
			BFilePanel *openpanel=new BFilePanel(B_OPEN_PANEL,m,&rif,B_DIRECTORY_NODE,false,NULL,NULL,true,true);
			openpanel->Show();
			}
		break;
		case 'Canc':
		
			win->PostMessage(B_QUIT_REQUESTED);
			be_app->PostMessage(B_QUIT_REQUESTED);
				
		break;
		case 'Save':
			{			
			
			BTextControl *txt=(BTextControl*)win->FindView("vstfolder");
			(new BAlert("info",txt->Text(),"is it cool?"))->Go();
				
			win->PostMessage(B_QUIT_REQUESTED);
			be_app->PostMessage(B_QUIT_REQUESTED);
			}
		break;
		case B_REFS_RECEIVED:
		
			if(message->FindRef("refs",&rif)==B_OK)
			{
		
				BTextControl *txt=(BTextControl*)win->FindView("vstfolder");
				txt->SetText(rif.name);
			}
		break;
		default:
			return true;
		break;
	}
	
	return true;

}
