/*******************************************************************************
/
/	File:			BzWindow.h
/
/	Description:	BWindow subclass that enable to redirect MessageReceived method
/				to another static function.
/				Usefull in project when you don't want to subclass a BWindow
/				or find 'dirty' to redirect the controls of the window to another BLooper.
/
/	Written by Anzani Andrea (oxygenum@tiscali.it)
/
*******************************************************************************/


#include "BzWindow.h"


void
BzWindow::RedirectMessages(RedirectFunc m_f,void* ck=NULL){

	m_func=m_f;
	cookies=ck;
}

void 
BzWindow::MessageReceived(BMessage *msg){

	bool b=false;
	if(m_func!=NULL)
		b=m_func(msg,cookies);
		
	if(b) BWindow::MessageReceived(msg);
}